#include <sys/ptrace.h>

#include <stdio.h>
#include <stdlib.h>

int main( int argc, char *argv[] ) {

  int rc = EXIT_SUCCESS;

  if ( argc < 3 ) {
    rc = 1;
    printf("Wrong amount of arguments.\n");
    printf("Usage:\n");
    printf("  %s <pid> <addr> [<addr> ...]\n", argv[0]);
    exit(rc);
  }

  char * pEnd;
  pid_t pid = strtoul(argv[1], &pEnd, 0);

  long errno;
  errno = ptrace(PTRACE_ATTACH, pid, 0, 0);

  if ( errno == -1 ) {
    rc = 2;
    printf("Cannot attach to process %d. You must be root or owner or pid does not exist.\n", pid);
    exit(rc);
  }
  
  pid_t wpid;
  int status;
  wpid = waitpid(pid, &status, 0);

  int i;
  long addr;
  long value;

  for ( i = 2; i < argc; i++ ) {

    addr = strtoul(argv[i], &pEnd, 0);
    value = ptrace(PTRACE_PEEKTEXT, pid, addr, 0);
    printf("%ld\n", value);
  }

  ptrace(PTRACE_DETACH, pid, 0x1, 0);
  waitpid(0, &status, 0);
  exit(rc);
}
